#include "stdafx.h"

#include <iostream>
#include <deque>
#include <string>
#include <cstdlib>

//#include "stack1.hpp"
//#include "stack2.hpp"
#include "stack3.hpp"

int _tmain(int argc, _TCHAR* argv[])
{
	try {
		Stack<int>         intStack;       // stack of ints
		Stack<double, std::deque<double> > dblStack;

		// manipulate int stack
		intStack.push(7);
		std::cout << intStack.top() << std::endl;
		intStack.pop();

		// manipulate string stack
		dblStack.push(23.64);
		std::cout << dblStack.top() << std::endl; 
		dblStack.pop();
		dblStack.pop();
	}
	catch (std::exception const& ex) {
		std::cerr << "Exception: " << ex.what() << std::endl;
		return EXIT_FAILURE;  // exit program with ERROR status
	}
}

