#include <vector>
#include <stdexcept>

template <typename T, typename CONT = std::vector<T> >
class Stack
{
private:
	CONT vecElem;

public:
	void push(T const&);
	void pop();
	T top() const;
	bool empty() const
	{
		return vecElem.empty();
	}
};

// ΰ ø Ķ͸ Ƿ Լǽ  
template <typename T, typename CONT>
void Stack<T, CONT>::push(T const& elem)
{
	vecElem.push_back(elem);
}

template <typename T, typename CONT>
void Stack<T, CONT>::pop()
{
	if(vecElem.empty())
		throw std::out_of_range("Stack pop");

	vecElem.pop_back();
}

template <typename T, typename CONT>
T Stack<T, CONT>::top() const
{
	if(vecElem.empty())
		throw std::out_of_range("Stack pop");

	return vecElem.back();
}